/*--------------------------------------------------------------------*/
/*       B r e a k S i g . c                                          */
/*                                                                    */
/*       Part of BinkD project                                        */
/*       Handle Ctrl-C & Ctrl-Break signals                           */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*       Copyright (c) 1996 by Fydodor Ustinov                        */
/*                             FIDONet 2:5020/79                      */
/*                                                                    */
/*  This program is  free software;  you can  redistribute it and/or  */
/*  modify it  under  the terms of the GNU General Public License as  */ 
/*  published  by the  Free Software Foundation; either version 2 of  */
/*  the License, or (at your option) any later version. See COPYING.  */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*                          RCS Information                           */
/*--------------------------------------------------------------------*/

/*
 *    $Id: BreakSig.c,v 1.01 1996/12/11 22:40:05 ufm Exp $
 *
 *    Revision history:
 *    $Log: BreakSig.c $
 *
 * Revision 1.01  1996/12/11  22:40:05  ufm
 *      First revision
 *
 */

 static const char rcsid[] =
      "$Id: BreakSig.c,v 1.01 1996/12/11 22:40:05 ufm Exp $";

/*--------------------------------------------------------------------*/
/*                        System include files                        */
/*--------------------------------------------------------------------*/

#include <windows.h>

/*--------------------------------------------------------------------*/
/*                        Local include files                         */
/*--------------------------------------------------------------------*/

#include "tools.h"
#include "iphdr.h"
#include "bsy.h"

/*--------------------------------------------------------------------*/
/*                         Global definitions                         */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*                          Global variables                          */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*                           Local variables                          */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*                    Local functions prototypes                      */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*    BOOL SigHandler(DWORD SigType)                                  */
/*                                                                    */
/*    Signal handler                                                  */
/*--------------------------------------------------------------------*/

BOOL SigHandler(DWORD SigType) {
BOOL rc;

   rc = TRUE;
   switch (SigType) {
      case CTRL_C_EVENT:
      case CTRL_BREAK_EVENT:
         log(1,"Interrupted by keyboard");
         break;
      case CTRL_CLOSE_EVENT:
         log(1,"Interrupted by Close");
         rc = FALSE;
         break;
      case CTRL_LOGOFF_EVENT:
         log(1,"Interrupted by LogOff");
         rc = FALSE;
         break;
      case CTRL_SHUTDOWN_EVENT:
         log(1,"Interrupted by Shutdown");
         rc = FALSE;
         break;
      default:
         log(1,"Interrupted by unknown signal");
         break;
   }
   bsy_remove_all();
   sock_deinit();

   return rc;
}

/*--------------------------------------------------------------------*/
/*    int HandleSignals(void)                                         */
/*                                                                    */
/*    Set signal handler                                              */
/*--------------------------------------------------------------------*/

int set_break_handlers () {
   if (SetConsoleCtrlHandler((PHANDLER_ROUTINE) &SigHandler,TRUE) != TRUE) {
      return (0);
   }
   return (1);
}
